// Ionic Starter App

// angular.module is a global place for creating, registering and retrieving Angular modules
// 'starter' is the name of this angular module example (also set in a <body> attribute in index.html)
// the 2nd parameter is an array of 'requires'
angular.module('starter', [
    'ionic',
    'starter.controllers',
    'starter.services',
    'starter.directives',
    'ionic.contrib.ui.tinderCards',
    'ngCordova',
    'openfb',
    'btford.socket-io',
    'ionic-ratings',
    'ionicLazyLoad',
]).constant('globalvars', {
    'serverUrl': 'https://api.petpalapps.com',
    'apiUrl': 'https://api.petpalapps.com/api/v1',
    'usersPath': '/Users/',
    'messsagesPath': '/Messages/',
    'conversationPath': '/Conversations/',
    'ratingPath': '/Rating/',
    'reportPath': '/reports'
})

.config(function($ionicConfigProvider) {
    $ionicConfigProvider.navBar.alignTitle('center');
    $ionicConfigProvider.views.swipeBackEnabled(true);
}).config(function($stateProvider, $urlRouterProvider) {
    $urlRouterProvider.otherwise('/root');

    $stateProvider
        .state('root', {
            url: '/root',
            controller: 'HomeCtrl'

        })
        .state('welcome', {
            url: '/welcome',
            templateUrl: 'templates/welcome/welcome.html',
            controller: 'WelcomeCtrl'
        })
     .state('home', {
            url: '/',
            abstract: true,
            templateUrl: 'templates/home/index.html'
        })
    .state('home.explore', {
            url: '/explore',
            templateUrl: 'templates/home/explore.html',
            controller: 'ExploreCtrl'
        })
    .state('home.profile', {
            url: '/profile:isFromCard?id?fbid?distance',
            templateUrl: 'templates/home/profile.html',
            controller: 'SingleProfileCtrl'
        })
    .state('settings', {
        url: '/settings',
        templateUrl: 'templates/home/settings.html',
        controller: 'SettingsCtrl'
    })

    .state('genderProfile', {
        url: '/genderprofile',
        templateUrl: 'templates/profile/gender.html',
        controller: 'genderProfileCtrl'
    })

    .state('ageProfile', {
        url: '/ageprofile',
        templateUrl: 'templates/profile/age.html',
        controller: 'ageProfileCtrl'
    })

    .state('breadProfile', {
        url: '/breadprofile',
        templateUrl: 'templates/profile/bread.html',
        controller: 'breadProfileCtrl'
    })

    .state('breadOption', {
        url: '/breadoption',
        templateUrl: 'templates/options/bread.html',
        controller: 'breadOptionsCtrl'
    })
    .state('typeProfile', {
        url: '/typeProfile',
        templateUrl: 'templates/profile/type.html',
        controller: 'typeProfileCtrl'
    })

    .state('typeOption', {
        url: '/typeOption',
        templateUrl: 'templates/options/type.html',
        controller: 'typeOptionsCtrl'
    })

    .state('genderOption', {
        url: '/genderoption',
        templateUrl: 'templates/options/gender.html',
        controller: 'genderOptionsCtrl'
    })

    .state('matches', {
        url: '/matches',
        templateUrl: 'templates/home/matches.html',
        controller: 'MatchesCtrl'
    })

    .state('feed', {
        url: '/feed',
        templateUrl: 'templates/home/feed.html',
        controller: 'FeedCtrl'
    })

    .state('meta', {
        url: '/meta',
        templateUrl: 'templates/home/meta.html',
        controller: 'MetaCtrl'
    })

    .state('gender', {
        url: '/gender',
        templateUrl: 'templates/home/gender.html',
        controller: 'GenderControler'
    })

    .state('editprofile', {
        url: '/editprofile',
        templateUrl: 'templates/modals/profile_edit.html',
        controller: 'ProfileEditControler'
    })

    .state('editsettings', {
        url: '/editsettings',
        templateUrl: 'templates/modals/settings.html',
        controller: 'SettingsEditControler'
    })

    .state('home.register', {
        url: '/register',
        templateUrl: 'templates/home/register.html',
        controller: 'UserPostController'
    })


    .state('home.messaging', {
        url: '/messaging/:id?matchid?pushid?name',
        templateUrl: 'templates/home/messaging.html',
        controller: 'MessagingCtrl'
    })
})
.run(function($rootScope, $state, $http, $ionicPlatform, $window, OpenFB, globalvars) {
    $ionicPlatform.ready(function() {
      window.localStorage.setItem("newnotification", false);

       window.plugins.OneSignal
     .startInit("9e972b01-0ac9-492e-9a9a-6a50312b5ee3", "552312569934")
     .inFocusDisplaying(window.plugins.OneSignal.OSInFocusDisplayOption.None)
     .handleNotificationOpened(function(jsonData) {

        console.log(jsonData);
        console.log(jsonData.notification.payload.additionalData.id);
        console.log(jsonData.notification.payload.additionalData.matchid);
        $rootScope.notificationData = jsonData;
        $state.go('home.messaging', ({id: jsonData.notification.payload.additionalData.id, matchid: jsonData.notification.payload.additionalData.matchid, pushid: jsonData.notification.payload.additionalData.pushid }));

      })
     .handleNotificationReceived(function(jsonData) {

         window.localStorage.setItem("newnotification", true);
         

     })
     .endInit();

      var isAppForeground = true;

          function initAds() {
            if (admob) {
              var adPublisherIds = {
                ios : {
                  banner : "ca-app-pub-3393319879803057/8926627521",
                  interstitial : "ca-app-pub-3393319879803057/4528610726"
                },
                android : {
                  banner : "ca-app-pub-3393319879803057/3158538321",
                  interstitial : "ca-app-pub-3393319879803057/4635271527"
                }
              };

              var admobid = (/(android)/i.test(navigator.userAgent)) ? adPublisherIds.android : adPublisherIds.ios;

              admob.setOptions({
                publisherId:      admobid.banner,
                interstitialAdId: admobid.interstitial,
                tappxIdiOS:       "/XXXXXXXXX/Pub-XXXX-iOS-IIII",
                tappxIdAndroid:   "/XXXXXXXXX/Pub-XXXX-Android-AAAA",
                adSize: admob.AD_SIZE.SMART_BANNER,
                tappxShare:  0.5,
                autoShowBanner:  false,
                autoShowInterstitial: false,
                overlap: true
              });

              registerAdEvents();

            } else {
              console.log("AdMobAds plugin not ready");
            }
          }

          function onAdLoaded(e) {
            if (isAppForeground) {
              if (e.adType === admob.AD_TYPE.INTERSTITIAL) {
                console.log("An interstitial has been loaded and autoshown. If you want to load the interstitial first and show it later, set 'autoShowInterstitial: false' in admob.setOptions() and call 'admob.showInterstitialAd();' here");
              } else if (e.adType === admob.AD_TYPE_BANNER) {
                console.log("New banner received");
              }
            }
          }

          function onPause() {
            if (isAppForeground) {
              admob.destroyBannerView();
              isAppForeground = false;
            }
          }

          function onResume() {
            if (!isAppForeground) {
              setTimeout(admob.createBannerView, 1);
              setTimeout(admob.requestInterstitialAd, 1);
              isAppForeground = true;
            }
          }

          // optional, in case respond to events
          function registerAdEvents() {
            document.addEventListener(admob.events.onAdLoaded, onAdLoaded);
            document.addEventListener(admob.events.onAdFailedToLoad, function (e) {});
            document.addEventListener(admob.events.onAdOpened, function (e) {});
            document.addEventListener(admob.events.onAdClosed, function (e) {});
            document.addEventListener(admob.events.onAdLeftApplication, function (e) {});
            document.addEventListener(admob.events.onInAppPurchaseRequested, function (e) {});

            document.addEventListener("pause", onPause, false);
            document.addEventListener("resume", onResume, false);
          }

           initAds();

          // display a banner at startup
           admob.createBannerView();
           admob.showBannerAd();
           admob.requestInterstitialAd();




        facebookConnectPlugin.getLoginStatus(function onLoginStatus(status) {
            var notificationObject = $rootScope.notificationData;

            console.log(notificationObject);
            var currentStatus = status.status;

            if (currentStatus == "connected") {

                facebookConnectPlugin.api("me/?fields=id,name,about", ["public_profile"],
                    function onSuccess(result) {
                        console.log(result);

                        facebookUserId = result.authResponse.userID;

                        queryUrl = globalvars.serverUrl + '/api/v1/Users?query={"facebookToken":"' + facebookUserId + '"}';


                        $http.get(queryUrl).then(function(res) {

                            var userID = res.data[0]._id;
                            window.localStorage.setItem("userIdToken", userID);
                            userUrl = globalvars.apiUrl + globalvars.usersPath + userID;
                            $http.get(userUrl).then(function(result){


                                  if (admob === true) {

                                     admob.showBannerAd();

                                  }


                                  else {

                                     admob.destroyBannerView();

                                  }


                            });


                        });


                    },
                    function onError(error) {
                        console.error("Failed: ", error);

                    }
                );
                $state.go('home.explore');
            } else {
                $state.go('welcome');
            }



        });


        if (window.cordova && window.cordova.plugins && window.cordova.plugins.Keyboard) {
            window.plugins.Keyboard.hideKeyboardAccessoryBar(true);
            window.plugins.Keyboard.disableScroll(true);
            $ionicConfigProvider.scrolling.jsScrolling(false);

        }
        if (window.StatusBar) {
            // org.apache.cordova.statusbar required
            StatusBar.styleDefault();
        }



    });
})


.run(function($rootScope, $state) {
    $rootScope.$state = $state;
})
