angular.module('starter.controllers', [])
  .controller('AppCtrl', function($scope, $state, $http, $ionicModal, OpenFB, globalvars) {
    $ionicModal.fromTemplateUrl('templates/modals/profile.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.profileModal = modal;
    });

    $scope.openProfileModal = function(isFromCard, _id, facebookToken) {

      var userId = _id;
      var facebokId = facebookToken;

      facebookConnectPlugin.api(facebokId + "/?fields=id,name,about", ["public_profile"],
              function onSuccess (result) {
                $scope.OwnerDetail = result;

              }, function onError (error) {
                console.error("Failed: ", error);
              }
      );

      var link = globalvars.apiUrl + globalvars.usersPath + userId;
      $http.get(link).then(function (res){

            console.log(res.data);
            $scope.cardUserDetails = res.data;


      });

      $scope.isFromCard = isFromCard;
      $scope.profileModal.show();

    }

    $scope.closeProfileModal = function() {
      $scope.profileModal.hide();
    };

    /*Edit Profile*/
    $ionicModal.fromTemplateUrl('templates/modals/profile_edit.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {

      $scope.editProfileModal = modal;

    });



    $scope.openEditProfileModal = function() {
      $scope.editProfileModal.show();

    }
    $scope.closeEditProfileModal = function() {
      $scope.editProfileModal.hide();
    };
  }).controller('UserPostController', function($scope,$http,$state,globalvars) {

    $scope.data = {};
    var formdata = $scope.data;

    // when submitting the add form, send the text to the node API
    $scope.postRegister = function() {


      $http.post(globalvars.apiUrl + globalvars.usersPath, {email: $scope.data.email, password: $scope.data.password}).then(function (res){
          $scope.response = res.data;
          console.log(res.data._id);

          $state.go('home.meta');
      });

    };

  }).controller('MetaCtrl', function($scope, $ionicPopup, $http, $state, $cordovaGeolocation, $ionicLoading, $cordovaCamera, $cordovaFileTransfer, ServiceLocation, globalvars) {

    $scope.data = {};
    var formdata = $scope.data;

    $scope.MetaUpdate = function() {
   var confirmPopup = $ionicPopup.confirm({
     title: 'Terms & Condition',
     template: 'By clicking Ok you agree to the Terms and Conditions.'
   });

   confirmPopup.then(function(res) {
     if(res) {
       var userId = window.localStorage.getItem("userIdToken");
       $http.put(globalvars.apiUrl + globalvars.usersPath + userId, {name: $scope.data.petname, type: $scope.data.type, bread: $scope.data.bread, gender: $scope.data.gender, age: $scope.data.age, weight:$scope.data.weight, personality: $scope.data.personality, verified: true}).then(function (res){
           $scope.response = res.data;
           $state.go('home.explore');

       });
     } else {
        $state.go('welcome');
     }
   });
 };





    document.addEventListener("deviceready", function () {
      options = {
        quality: 80,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
        mediaType: Camera.MediaType.PICTURE,
        allowEdit: true,
        encodingType: Camera.EncodingType.JPEG,
        targetWidth: 800,
        targetHeight: 800,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation:true
      };
    });

    $scope.ProfileOwnerPicUpload = function() {

      if (Camera === undefined) return false;

      $cordovaCamera.getPicture(options)
        .then(function(imageData) {
          // $scope.imgSrc = "data:image/jpeg;base64," + imageData;

          console.log(imageData);
          $ionicLoading.show({
            template: '<ion-spinner></ion-spinner>'
          });

          var url = globalvars.serverUrl + "/profile/upload";
 //target path may be local or url
          var targetPath = imageData;
          var filename = targetPath.split("/").pop();
          var options = {
              fileKey: "avatar",
              fileName: filename,
              chunkedMode: false,
              mimeType: "image/jpg"
          };
    $cordovaFileTransfer.upload(url, targetPath, options).then(function(result) {


            var userId = window.localStorage.getItem("userIdToken");
            var link = globalvars.apiUrl + globalvars.usersPath + userId;
            $http.put(link, {images:  {ownerPic: result.response} });
            $ionicLoading.hide();


        }, function(err) {
            console.log(err);

        }, function (progress) {
              console.log(progress);
    });





        }, function(err) {
          // error
        });

    };


    $scope.ProfilePetPicUpload = function() {

      if (Camera === undefined) return false;

      $cordovaCamera.getPicture(options)
        .then(function(imageData) {
          // $scope.imgSrc = "data:image/jpeg;base64," + imageData;

          console.log(imageData);
          $ionicLoading.show({
            template: '<ion-spinner></ion-spinner>'
          });

          var url = globalvars.serverUrl + "/profile/upload";
 //target path may be local or url
          var targetPath = imageData;
          var filename = targetPath.split("/").pop();
          var options = {
              fileKey: "avatar",
              fileName: filename,
              chunkedMode: false,
              mimeType: "image/jpg"
          };
    $cordovaFileTransfer.upload(url, targetPath, options).then(function(result) {


            var userId = window.localStorage.getItem("userIdToken");
            var link = globalvars.apiUrl + globalvars.usersPath + userId;
            $http.put(link, {images:  {positionOne: result.response} });
            $ionicLoading.hide();


        }, function(err) {
            console.log(err);

        }, function (progress) {
              console.log(progress);
    });





        }, function(err) {
          // error
        });

    };

  })

  .controller('SingleProfileCtrl', function($scope, $http, $ionicPopup, $stateParams, $state, $ionicLoading, $timeout, $ionicModal, $location, globalvars, $ionicActionSheet) {


    var userId = $stateParams.id;
    var facebokId = $stateParams.fbid;
    var isFromCard = $stateParams.isFromCard;
    var distance = $stateParams.distance;

    var reportedBy =  window.localStorage.getItem("userIdToken");
    console.log($stateParams);




    facebookConnectPlugin.api(facebokId + "/?fields=id,name,about", ["public_profile"],
            function onSuccess (result) {
              $scope.OwnerDetail = result;

            }, function onError (error) {
              console.error("Failed: ", error);
            }
    );



    $scope.distance = $stateParams.distance;
    var link = globalvars.apiUrl + globalvars.usersPath + userId;
    var report = globalvars.apiUrl + globalvars.reportPath;
    var me = globalvars.apiUrl + globalvars.usersPath + reportedBy;
    $http.get(me).then(function(result){

      console.log(result.data);
      $scope.userDetails = result.data;

    });
    $http.get(link).then(function (res){

         console.log(res.data);
          $scope.cardUserDetails = res.data;


    });

    $scope.isFromCard = isFromCard;
    $scope.showUserOptions = function() {


      $http.get(me).then(function(result){


            if (result.data.admob === true) {
                admob.showBannerAd(false);

            }



      });



      var hideSheet = $ionicActionSheet.show({
        buttons: [


          { text: 'Report ' +  $scope.cardUserDetails.name },

        ],
        cancelText: 'Cancel',
        cancel: function() {
          $http.get(me).then(function(result){


                if (result.data.admob === true) {
                    admob.showBannerAd(true);

                }



          });
          },
        buttonClicked: function(index) {
          console.log(index);
          $http.get(me).then(function(result){


                if (result.data.admob === true) {
                    admob.showBannerAd(true);

                }



          });
          if (index === 0) {
              $http.post(report, {reportedUser: userId, reportedBy: reportedBy });
          }
          return true;
        }
      });
    }




      $scope.openPopup = function() {

        var petName = $scope.cardUserDetails.name;
          ratingPopup = $ionicPopup.show({
         scope: $scope,
         templateUrl: 'templates/modals/rating.html',
         title: "Review " + petName,
         buttons: [
            { text: 'Cancel',
          type: 'button-energized' }
         ]
       });

       ratingPopup.then(function(res) {
         console.log('Rating Fired');
       });

     };



     $scope.ratingsObject = {
       iconOn: 'ion-ios-star large-star',    //Optional
       iconOff: 'ion-ios-star large-star',   //Optional
       iconOnColor: 'rgb(240, 105, 25)',  //Optional
       iconOffColor:  'rgb(225, 225, 225)',    //Optional
       rating:  0, //Optional
       minRating:1,    //Optional
       readOnly: true, //Optional
       callback: function(rating, index) {    //Mandatory
         $scope.ratingsCallback(rating, index);
       }
     };

     $scope.ratingsCallback = function(rating, index, currentUserId) {
        var currentUserId = $scope.cardUserDetails._id;
       console.log('Selected rating is : ', rating, ' and the index is : ', index);
       var link = globalvars.apiUrl + globalvars.ratingPath
       $http.post(link, {userId: currentUserId, rating: rating});
       ratingPopup.close();
     };



  })

    .controller('WelcomeCtrl', function($scope, $http, $state, $ionicPlatform, $ionicLoading, $timeout, $location, globalvars) {



              $scope.loginNative = function () {


                var fbLoginSuccess = function (userData) {

                  facebookUserId = userData.authResponse.userID;
                  console.log(userData);
                  facebookConnectPlugin.api("me/?fields=id,name,about", ["public_profile"],
                             function onSuccess (result) {
                               console.log(result);
                               var facebookUserIdNew = result.id;
                              window.localStorage.setItem("fbuserId", result.id);
                              window.localStorage.setItem("fbuserName", result.name);
                              window.localStorage.setItem("fbuserAbout", result.about);

                             }, function onError (error) {
                               console.error("Failed: ", error);
                             }
                   );



                  queryUrl = globalvars.serverUrl + '/api/v1/Users?query={"facebookToken":"' + facebookUserId + '"}';


                  $http.get(queryUrl).then(function (res){




                              console.log(res.data.length);



                              if (res.data.length === 0) {


                                $http.post(globalvars.apiUrl + globalvars.usersPath, {"facebookToken": facebookUserId}).then(function(result){

                                      console.log(result);
                                      console.log(result.data._id);
                                      window.localStorage.setItem("userIdToken", result.data._id);
                                      $state.go('meta');

                                });


                              }

                              else {

                                userId = res.data[0]._id;
                                window.localStorage.setItem("userIdToken", userId);
                                verified = res.data[0].verified;
                                admob = res.data[0].admob;
                                console.log(res.data);


                                if (verified === true) {


                                    $state.go('home.explore');

                                }
                                else {

                                  console.log("Wrong");
                                  $state.go('meta');

                                }


                              }



                     });



                }


                facebookConnectPlugin.login(["public_profile", "user_birthday"], fbLoginSuccess,
                          function (error) {
                                  console.error(error)
                          }
                 );

              };




  })

  .controller('FeedCtrl', function($scope, $http, $timeout, $ionicModal, $stateParams, $ionicLoading, $state, ServiceLocation, globalvars) {

        $scope.userscount = 0;
        var userId = window.localStorage.getItem("userIdToken");
        var facebookToken = window.localStorage.getItem("fbuserId");
        var link = globalvars.apiUrl + globalvars.usersPath + userId;
        var seenUsers = [];
        var currentUserPush = facebookToken;
        var cardUserId;
        seenUsers.push(currentUserPush);
        var seen = globalvars.apiUrl + '/Seen?query={"userId":"' + userId + '"}';

        $ionicLoading.show({
          template: '<ion-spinner></ion-spinner>'
        });

        $http.get(seen).then(function (res){

              angular.forEach(res.data, function(data) {

                   var pushNode =  data.facebookToken;
                   seenUsers.push(pushNode);

              });


        });

        $scope.getRates = function(data){
            console.log(data.length);

            if (typeof(data) === 'undefined') {
                return 0;
            }

            var sum = 0;
            for (var i = data.length - 1; i >= 0; i--) {
                sum += parseInt(data[i].rating);
            }

            var count = data.length;
            var total = sum / count;
            if (total === null) {
                var rating = 5;
            }

            else {
              var rating = total;
            }
            return rating;

            console.log(rating);
       };


    setTimeout(function(){

      $http.get(link).success(function (res){

        console.log(res);
        $scope.userDetails = res;

        console.log(res.loc);
        var coordinates = res.loc.coordinates;
        var distance = res.options.maxDistance;
        var maxDistance = distance;
        var gender = res.options.gender;
        var age = res.options.age;
        var bread = res.options.bread;
        var type = res.options.type;
        var coordinates = res.loc.coordinates;
        var currentFbToken = facebookToken;
        console.log("explore coordinates");
        console.log(coordinates);

        $http.post( globalvars.serverUrl + '/allusers', {type: type, currentFbToken: currentFbToken, gender: gender, bread: bread, age: age, maxDistance: maxDistance, userId: userId, coordinates: coordinates}).then(function(result){


                     $scope.cards = result.data;

                     $scope.feedDisLike = function(event, _id, facebookToken, index) {


                       $scope.userscount++;

                       $scope.$watch("userscount", function(newValue, oldValue) {
                              if ($scope.userscount === 10) {
                                  admob.showInterstitialAd();
                              }
                        });

                       var facebookId = facebookToken.facebookToken;
                       event.stopPropagation();
                       var DislikeLink = globalvars.serverUrl + '/api/v1/Dislikes';

                       facebookTokenData = facebookToken.facebookToken;

                       $http.post(DislikeLink, {DislikedUserId: _id, userId: userId, facebookToken: facebookId, created_at: moment()});

                       $scope.message = '';
                       $scope.DisshowMessage = true;
                       $timeout(function() {
                          $scope.DisshowMessage = false;
                       }, 1000);

                       $timeout(function(){
                         $scope.cards.splice(index, 1);
                       }, 500);

                     }

                     $scope.feedLike = function(event, _id, facebookToken, index, distance) {


                       $scope.userscount++;

                       $scope.$watch("userscount", function(newValue, oldValue) {
                              if ($scope.userscount === 10) {
                                  admob.showInterstitialAd();
                              }
                        });


                       facebookTokenData = facebookToken.facebookToken;
                       var matchDistance = distance.distance;

                       console.log(distance);


                       console.log(facebookTokenData);
                       event.stopPropagation();
                       var likeLink = globalvars.serverUrl + '/api/v1/Likes';
                       var seenLink = globalvars.serverUrl + '/api/v1/Seen';
                       var conversationLink = globalvars.serverUrl + '/api/v1/Conversations';

                       $http.post(seenLink, {userId: userId, SeenUserId: _id, facebookToken: facebookTokenData, created_at: moment()});
                       $http.post(likeLink, {userId: userId, LikedUserId: _id, facebookToken: facebookTokenData, created_at: moment()}).success(function(data){


                              var query = globalvars.serverUrl + '/api/v1/Likes?query={"userId":"' + _id._id +'", "LikedUserId": "' + userId + '"}';
                              $http.get(query).success(function(result){


                                if (result.length > 0) {
                                  console.log("its a match");
                                  $http.post(conversationLink, {matchedUsers:  [_id._id, userId] }).then(function(result){

                                            var conversationId = result.data._id;
                                            cardUserId = _id._id;
                                            $scope.openMatchModal(cardUserId, matchDistance, conversationId);
                                  });



                                }
                                else {
                                  console.log("not matched yet!");
                                }

                                  //

                              });


                       });



                       $scope.message = '';
                       $scope.showMessage = true;
                       $timeout(function() {
                          $scope.showMessage = false;
                       }, 1000);

                       $timeout(function(){
                         $scope.cards.splice(index, 1);
                       }, 500);


                     }

                     // Match popup
                     $ionicModal.fromTemplateUrl('templates/modals/match.html', {
                       scope: $scope,
                       animation: 'slide-in-up'
                     }).then(function(modal) {
                       $scope.matchModal = modal;
                     });

                     $scope.openMatchModal = function(cardUserId, matchDistance, conversationId) {

                       console.log(matchDistance);
                       $scope.distance = matchDistance;
                       $scope.conversationId = conversationId;

                       var link = globalvars.apiUrl + globalvars.usersPath + cardUserId;
                       $http.get(link).success(function(result){
                             console.log(result);
                             console.log(result.name);
                             $scope.matchedUserDetails = result;


                       });

                       $scope.matchModal.show();
                     }
                     $scope.closeMatchModal = function() {
                       $scope.matchModal.hide();
                     };

                     $scope.goConversation = function(data) {

                       console.log(data);
                       var conversationId = data.id;
                       var matcheduserid = data.matchid;
                       var matchedpushId = data.pushid;

                       $state.go('home.messaging', {id: conversationId, matchid: matcheduserid, pushid: matchedpushId});
                       $scope.matchModal.hide();

                     };


                     $ionicLoading.hide();


                });




      });


    }, 3000);

    $scope.admobremove = window.localStorage.getItem("admob");


    $ionicModal.fromTemplateUrl('templates/modals/help.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.helpModal = modal;
    });

    $scope.closeHelpModal = function() {
      $scope.helpModal.hide();
      $http.get(link).then(function(result){


            if (result.data.admob === true) {
                admob.showBannerAd(true);

            }



      });
    };

    $scope.openHelpModal = function() {
      $http.get(link).then(function(result){


            if (result.data.admob === true) {
                admob.showBannerAd(false);

            }



      });
    }



    }


   )
  .controller('HomeCtrl', function($scope, $http, $ionicModal, $ionicLoading, $state, ServiceLocation, GetAllUsers, globalvars){



  })
  .controller('ExploreCtrl', function($scope, $http, $ionicModal, $ionicLoading, $state, ServiceLocation, GetAllUsers, globalvars) {





    var newnotification = window.localStorage.getItem("newnotification");

    var userId = window.localStorage.getItem("userIdToken");
    var facebookToken = window.localStorage.getItem("fbuserId");
    var link = globalvars.apiUrl + globalvars.usersPath + userId;



    $scope.admobremove = false;
    $scope.newnotification = newnotification;
    var admobstatus = window.localStorage.getItem("admob");
    console.log(admobstatus);

    inAppPurchase
  .restorePurchases()
  .then(function (data) {
  console.log(data);
  if (data.length === 0) {

    console.log("purchased");


  } else {

    $http.put(link, {admob: false});
    console.log("not purchased");
  }
  })
  .catch(function (err) {
  console.log(err);
  });



    $http.get(link).then(function(result){


          if (result.data.admob === true) {
            setTimeout(function(){    admob.showBannerAd(true); }, 1000);

          }
          else {
            setTimeout(function(){    admob.showBannerAd(false); }, 1000);
          }


    });


    $scope.userscount = 0;


    window.plugins.OneSignal.getIds(function(ids) {

            $http.patch(link, {pushId:  ids.userId});
            console.log(ids);
    });

    var seenUsers = [];
    var currentUserPush = facebookToken;
    var cardUserId;
    seenUsers.push(currentUserPush);
    var seen = globalvars.apiUrl + '/Likes?query={"userId":"' + userId + '"}';
    ServiceLocation.getPosition()
    .then(function(position) {

      $http.patch(link, {loc: { type: "Point", coordinates: [position.coords.longitude, position.coords.latitude] }});
    }, function(err) {

    });

    $ionicLoading.show({
      template: '<ion-spinner></ion-spinner>'
    });



    $http.get(seen).then(function (res){

          angular.forEach(res.data, function(data) {

               var pushNode =  data.facebookToken;
               seenUsers.push(pushNode);

          });


    });


    setTimeout(function(){

      $http.get(link).success(function (res){

                console.log(res);
                $scope.userDetails = res;

                console.log(res.loc);
                var coordinates = res.loc.coordinates;
                var distance = res.options.maxDistance;
                var maxDistance = distance;
                var gender = res.options.gender;
                var age = res.options.age;
                var bread = res.options.bread;
                var type = res.options.type;
                var coordinates = res.loc.coordinates;
                var currentFbToken = facebookToken;
                console.log("explore coordinates");
                console.log(coordinates);

                $http.post( globalvars.serverUrl + '/allusers', {type: type, currentFbToken: currentFbToken, gender: gender, bread: bread, age: age, maxDistance: maxDistance, userId: userId, coordinates: coordinates}).then(function(result){

                    console.log(result);


                     var cards = result.data;
                     var resetCards = angular.copy(cards);
                     $scope.cards = [];




                     function _addCards(quantity) {
                       for (var i = 0; i < Math.min(cards.length, quantity); i++) {
                         $scope.cards.push(cards[0]);
                         cards.splice(0, 1);
                       }
                     }



                     $scope.me = window.localStorage.getItem("userIdToken");

                     $scope.isMe = function(user){
                       if($scope.me === user){
                         return true;
                       }
                       return false;
                     };

                     $scope.cardDestroyed = function(index) {

                       $scope.cards.splice(index, 1);
                       console.log(index);
                       _addCards(1);
                       $scope.isMoveLeft = false;
                       $scope.isMoveRight = false;
                       $scope.userscount++;

                       $scope.$watch("userscount", function(newValue, oldValue) {
                              if ($scope.userscount === 10) {


                                $http.get(link).then(function(result){

                                      if (result.data.admob === true) {
                                            admob.showInterstitialAd();
                                      }


                                });



                              }
                        });

                     };

                     $scope.cardSwiped = function(index) {
                       console.log(index);
                       $scope.cards.push(cards[Math.floor(Math.random(1)*8)]);
                     };

                     // For reasons, the cardSwipedRight and cardSwipedLeft events don’t get called always
                     // https://devdactic.com/optimize-tinder-cards/
                     $scope.cardSwipedLeft = function(event, index, _id, facebookToken) {

                       console.log(index);
                       console.log(_id._id);
                       event.stopPropagation();
                       var DislikeLink = globalvars.serverUrl + '/api/v1/Dislikes';
                       var seenLink = globalvars.serverUrl + '/api/v1/Seen';

                       facebookTokenData = facebookToken.facebookToken;


                       $http.post(DislikeLink, {userId: userId, DislikedUserId: _id._id, facebookToken: facebookTokenData, created_at: moment()});

                     }

                     $scope.cardDisLike = function(index) {


                       var facebookTokenData = $scope.cards[0].facebookToken;
                       var _id = $scope.cards[0]._id;


                       $scope.cards.splice(index, 1);
                       _addCards(1);
                       $scope.isMoveLeft = false;
                       $scope.isMoveRight = false;




                       var DislikeLink = globalvars.serverUrl + '/api/v1/Dislikes';






                       $http.post(DislikeLink, {userId: userId, DislikedUserId: _id, facebookToken: facebookTokenData, created_at: moment()});

                     }

                     $scope.cardLike = function(index) {


                       var facebookTokenData = $scope.cards[0].facebookToken;
                       var matchDistance = $scope.cards[0].distance;
                       var _id = $scope.cards[0]._id;

                       $scope.cards.splice(index, 1);
                       _addCards(1);
                       $scope.isMoveLeft = false;
                       $scope.isMoveRight = false;


                       var likeLink = globalvars.serverUrl + '/api/v1/Likes';
                       var seenLink = globalvars.serverUrl + '/api/v1/Seen';
                       var conversationLink = globalvars.serverUrl + '/api/v1/Conversations';


                       $http.post(likeLink, {userId: userId, LikedUserId: _id, facebookToken: facebookTokenData, created_at: moment()}).success(function(data){


                              var query = globalvars.serverUrl + '/api/v1/Likes?query={"userId":"' + _id +'", "LikedUserId": "' + userId + '"}';
                              $http.get(query).success(function(result){


                                if (result.length > 0) {
                                  console.log("its a match");
                                  $http.post(conversationLink, {matchedUsers:  [_id, userId] }).then(function(result){

                                            var conversationId = result.data._id;
                                            cardUserId = _id;
                                            $scope.openMatchModal(cardUserId, matchDistance, conversationId);

                                  });



                                }
                                else {
                                  console.log("not matched yet!");
                                }

                                  //

                              });


                       });


                     }

                     $scope.cardSwipedRight = function(event, index, _id, facebookToken, distance) {



                       facebookTokenData = facebookToken.facebookToken;
                       var matchDistance = distance.distance;

                       console.log(distance);


                       console.log(facebookTokenData);
                       event.stopPropagation();
                       var likeLink = globalvars.serverUrl + '/api/v1/Likes';

                       var conversationLink = globalvars.serverUrl + '/api/v1/Conversations';


                       $http.post(likeLink, {userId: userId, LikedUserId:_id._id, facebookToken: facebookTokenData, created_at: moment()}).success(function(data){


                              var query = globalvars.serverUrl + '/api/v1/Likes?query={"userId":"' + _id._id +'", "LikedUserId": "' + userId + '"}';
                              $http.get(query).success(function(result){


                                if (result.length > 0) {
                                  console.log("its a match");
                                  $http.post(conversationLink, {matchedUsers:  [_id._id, userId] }).then(function(result){

                                            var conversationId = result.data._id;
                                            cardUserId = _id._id;
                                            $scope.openMatchModal(cardUserId, matchDistance, conversationId);
                                  });



                                }
                                else {
                                  console.log("not matched yet!");
                                }

                                  //

                              });


                       });


                     }

                     $scope.cardPartialSwipe = function(amt) {
                       $scope.isMoveLeft = amt < -0.15;
                       $scope.isMoveRight = amt > 0.15;
                     }


                     // Match popup
                     $ionicModal.fromTemplateUrl('templates/modals/match.html', {
                       scope: $scope,
                       animation: 'slide-in-up'
                     }).then(function(modal) {
                       $scope.matchModal = modal;
                     });

                     $scope.openMatchModal = function(cardUserId, matchDistance, conversationId) {


                       console.log(matchDistance);
                       $scope.distance = matchDistance;
                       $scope.conversationId = conversationId;
                       var currentUserName = $scope.userDetails.name;
                       console.log(currentUserName);

                       var link = globalvars.apiUrl + globalvars.usersPath + cardUserId;
                       $http.get(link).success(function(result){
                             console.log(result);
                             console.log(result.name);
                             $scope.matchedUserDetails = result;
                             window.plugins.OneSignal.getIds(function(ids) {
                                 var notificationObj = { contents: {en: currentUserName + " likes you, send a message"},
                                                   include_player_ids: [result.pushId]};
                                 window.plugins.OneSignal.postNotification(notificationObj,
                                   function(successResponse) {
                                       console.log("Notification Post Success:", successResponse);
                                 },
                                 function (failedResponse) {
                                       console.log("Notification Post Failed: ", failedResponse);

                                 }
                                 );
                             });

                       });

                       $scope.matchModal.show();
                     }

                     $scope.closeMatchModal = function() {
                       $scope.matchModal.hide();


                     };

                     $scope.goConversation = function(data){



                          console.log(data);
                          var conversationId = data.id;
                          var matcheduserid = data.matchid;
                          var matchedpushId = data.pushid;

                          $state.go('home.messaging', {id: conversationId, matchid: matcheduserid, pushid: matchedpushId});
                          $scope.matchModal.hide();

                     };

                     // Onload
                     _addCards(25);
                     $ionicLoading.hide();


                });


      });


    }, 4000);



    $ionicModal.fromTemplateUrl('templates/modals/help.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {


      $scope.helpModal = modal;
    });

    $scope.closeHelpModal = function() {
       $scope.helpModal.hide();


       $http.get(link).then(function(result){


             if (result.data.admob === true) {
                 admob.showBannerAd(true);

             }



       });


    };

    $scope.openHelpModal = function() {
      $scope.helpModal.show();
      $http.get(link).then(function(result){

            if (result.data.admob === true) {
                  admob.showBannerAd(false);
            }


      });

    };





  })
  .controller('typeProfileCtrl', function($scope, $ionicModal, $http, $stateParams, ProfileFactory, $state, globalvars) {

    $scope.types = [
                { title: "Bird" },
                { title: "Cat" },
                { title: "Dog" }

                  ];


                $scope.clicker = function(type){



                        var userId = window.localStorage.getItem("userIdToken");
                        var link = globalvars.apiUrl + globalvars.usersPath + userId;
                        $http.put(link, {type: type.title}).then(function(data){

                              $state.go('editprofile');

                        });




                  };


  })

  .controller('typeOptionsCtrl', function($scope, $ionicModal, $http, $stateParams, ProfileFactory, $state, globalvars) {

    $scope.types = [
                { title: "All" },
                { title: "Bird" },
                { title: "Cat" },
                {title: "Dog"}

                  ];


                $scope.clicker = function(type){



                        var userId = window.localStorage.getItem("userIdToken");
                        var link = globalvars.apiUrl + globalvars.usersPath + userId;
                        $http.put(link, {options: {type: type.title}}).then(function(data){

                              $state.go('editsettings');

                        });




                  };


  })
  .controller('genderProfileCtrl', function($scope, $ionicModal, $http, $stateParams, ProfileFactory, $state, globalvars) {

    $scope.genders = [
                { title: "Male" },
                { title: "Female" }

                  ];


                $scope.clicker = function(data){


                        console.log(data.title);
                        var userId = window.localStorage.getItem("userIdToken");
                        var link = globalvars.apiUrl + globalvars.usersPath + userId;
                        $http.put(link, {gender: data.title}).then(function(data){

                              $state.go('editprofile');

                        });




                  };


  })

  .controller('genderOptionsCtrl', function($scope, $ionicModal, $http, $stateParams, ProfileFactory, $state, globalvars) {

    $scope.genders = [
                { title: "All" },
                { title: "Male" },
                { title: "Female" }

                  ];


                $scope.clicker = function(gender){



                  var userId = window.localStorage.getItem("userIdToken");
                  var link = globalvars.apiUrl + globalvars.usersPath + userId;
                  $http.put(link, {options: {gender: gender.title}}).then(function(data){

                        $state.go('editsettings');

                  });




                  };


  })

  .controller('ageProfileCtrl', function($scope, $ionicModal, $http, $stateParams, AgeFactory, $state, globalvars) {

    $scope.ages = [
                { id: 0 },
                { id: 1 },
                { id: 2 },
                { id: 3 },
                { id: 4 },
                { id: 5 },
                { id: 6 },
                { id: 7 },
                { id: 8 },
                { id: 9 },
                { id: 10 },
                { id: 11 },
                { id: 12 },
                { id: 13 },
                { id: 14 },
                { id: 15 },
                { id: 16 },
                { id: 17 },
                { id: 10 },
                { id: 19 },
                { id: 20 },
                { id: 21 },
                { id: 22 }

                  ];


                $scope.clicker = function(age){



                        var userId = window.localStorage.getItem("userIdToken");
                        var link = globalvars.apiUrl + globalvars.usersPath + userId;
                        $http.put(link, {age: age.id}).then(function(data){

                              $state.go('editprofile');

                        });




                  };

  })
  .controller('breadProfileCtrl', function($scope, $ionicModal, $http, $stateParams, ProfileFactory, $state, globalvars) {

    $scope.clearSearch = function() {
    $scope.search = '';
  };


    $scope.breads = [
                { title: "Mutt-Madness Surprise Mix!"},
                { title: "Mini Mutts (Mucho Love!)"},
                { title: "Mid-Sized Mutts"},
                { title: "Big Mutt-hatten Sky Scrapers"},
                { title: "Barrymore's Buddies"},
                { title: "Taco Bell Dog's Little Amigos"},
                { title: "Eddie &amp; Frasier's Friends!"},
                { title: "Affenpinscher"},
                { title: "Afghan Hound"},
                { title: "Ain't Nothin' but a Hound Dog!"},
                { title: "Airedale Terrier"},
                { title: "Akbash"},
                { title: "Akita"},
                { title: "Alaskan Malamute"},
                { title: "Almost a Horse"},
                { title: "American Bulldog"},
                { title: "American Eskimo Dog"},
                { title: "American Hairless Terrier"},
                { title: "American Pit Bull Terrier"},
                { title: "American Staffordshire Terrier"},
                { title: "American Water Spaniel"},
                { title: "Anatolian Shepherd"},
                { title: "Australian Cattle Dog"},
                { title: "Australian Kelpie"},
                { title: "Australian Shepherd"},
                { title: "Australian Terrier"},
                { title: "Basenji"},
                { title: "Basset Griffon Vendeen"},
                { title: "Basset Hound"},
                { title: "Beagle"},
                { title: "Bearded Collie"},
                { title: "Beauceron"},
                { title: "Bedlington Terrier"},
                { title: "Belgian Laekenois"},
                { title: "Belgian Malinois"},
                { title: "Belgian Shepherd"},
                { title: "Belgian Tervuren"},
                { title: "Bernese Mountain Dog"},
                { title: "Bichon Frise"},
                { title: "Black Mouth Cur"},
                { title: "Black and Tan Coonhound"},
                { title: "Bloodhound"},
                { title: "Blue Heeler"},
                { title: "Lacy/Texas Lacy"},
                { title: "Bluetick Coonhound"},
                { title: "Bobtail"},
                { title: "Bolognese"},
                { title: "Border Collie"},
                { title: "Border Terrier"},
                { title: "Borzoi"},
                { title: "Boston Terrier"},
                { title: "Bouvier des Flandres"},
                { title: "Boxer"},
                { title: "Boykin Spaniel"},
                { title: "Briard"},
                { title: "Brittany"},
                { title: "Brussels Griffon"},
                { title: "Bull Terrier"},
                { title: "Bulldog"},
                { title: "Bullmastiff"},
                { title: "Cairn Terrier"},
                { title: "Canaan Dog"},
                { title: "Canary Dog"},
                { title: "Cane Corso"},
                { title: "Cardigan Welsh Corgi"},
                { title: "Carolina Dog"},
                { title: "Catahoula Leopard Dog"},
                { title: "Cattle Dog"},
                { title: "Cavalier King Charles Spaniel"},
                { title: "Chesapeake Bay Retriever"},
                { title: "Chihuahua"},
                { title: "Chinese Crested"},
                { title: "Chow Chow"},
                { title: "Clumber Spaniel"},
                { title: "Cockapoo"},
                { title: "Cocker Spaniel"},
                { title: "Collie"},
                { title: "Coonhound"},
                { title: "Coonhounds"},
                { title: "Corgi"},
                { title: "Coton de Tulear"},
                { title: "Curly-Coated Retriever"},
                { title: "Cute Canine Crosses"},
                { title: "Dachshund"},
                { title: "Dalmatian"},
                { title: "Dandie Dinmont Terrier"},
                { title: "Deerhound"},
                { title: "Doberman Pinscher"},
                { title: "Dogo Argentino"},
                { title: "Dogue de Bordeaux"},
                { title: "Dutch Shepherd"},
                { title: "English Coonhound"},
                { title: "English Bulldog"},
                { title: "English Mastiff"},
                { title: "English Pointer"},
                { title: "English Setter"},
                { title: "English Sheepdog"},
                { title: "English Shepherd"},
                { title: "English Springer Spaniel"},
                { title: "English Toy Spaniel"},
                { title: "Entlebucher"},
                { title: "Eskimo Dog"},
                { title: "Eskimo Spitz"},
                { title: "Fantastic Fidos"},
                { title: "Feist"},
                { title: "Field Spaniel"},
                { title: "Fila Brasileiro"},
                { title: "Finnish Lapphund"},
                { title: "Finnish Spitz"},
                { title: "Flat-Coated Retriever"},
                { title: "Fox Terrier (Smooth)"},
                { title: "Fox Terrier (Toy)"},
                { title: "Fox Terrier (Wirehaired)"},
                { title: "Fox Terriers (All Types)"},
                { title: "Foxhound"},
                { title: "French Bulldog"},
                { title: "French Mastiff"},
                { title: "Funny-Faced Breeds"},
                { title: "German Pinscher"},
                { title: "German Shepherd Dog"},
                { title: "German Shorthaired Pointer"},
                { title: "German Wirehaired Pointer"},
                { title: "Giant Schnauzer"},
                { title: "Glen of Imaal Terrier"},
                { title: "Go Fetch! Retrievers!"},
                { title: "Golden Retriever"},
                { title: "Goldendoodle"},
                { title: "Gordon Setter"},
                { title: "Great Dane"},
                { title: "Great Pyrenees"},
                { title: "Greater Swiss Mountain Dog"},
                { title: "Greyhound"},
                { title: "Halden Hound"},
                { title: "Harrier"},
                { title: "Havanese"},
                { title: "Hounds (All Types)"},
                { title: "Hounds (Scent Hounds)"},
                { title: "Hounds (Sight Hounds)"},
                { title: "Hovawart"},
                { title: "Hungarian Puli"},
                { title: "Hungarian Water Dog"},
                { title: "Husky"},
                { title: "Ibizan Hound"},
                { title: "Irish Setter"},
                { title: "Irish Terrier"},
                { title: "Irish Water Spaniel"},
                { title: "Irish Wolfhound"},
                { title: "Italian Greyhound"},
                { title: "Italian Spinone"},
                { title: "Jack Russell Terrier"},
                { title: "Japanese Chin"},
                { title: "Jindo"},
                { title: "Kai Dog"},
                { title: "Karelian Bear Dog"},
                { title: "Keeshond"},
                { title: "Kerry Blue Terrier"},
                { title: "King Charles Spaniel"},
                { title: "Kishu"},
                { title: "Komondor"},
                { title: "Kuvasz"},
                { title: "Kyi Leo"},
                { title: "Labradoodle"},
                { title: "Labrador Retriever"},
                { title: "Lakeland Terrier"},
                { title: "Lancashire Heeler"},
                { title: "Lassie's Friends!"},
                { title: "Leonberger"},
                { title: "Lhasa Apso"},
                { title: "Little Fluffy Powder-Puffs of Love"},
                { title: "Little Lovers"},
                { title: "Löwchen"},
                { title: "Maltese"},
                { title: "Manchester Terrier"},
                { title: "Maremma Sheepdog"},
                { title: "Marvelous Mixes"},
                { title: "Mastiff"},
                { title: "Mastiffs (All Types)"},
                { title: "Mexican Hairless"},
                { title: "Miniature Pinscher"},
                { title: "Miniature Poodle"},
                { title: "Miniature Schnauzer"},
                { title: "Mountain Cur"},
                { title: "Munsterlander"},
                { title: "Muttchkins"},
                { title: "Neapolitan Mastiff"},
                { title: "Newfoundland"},
                { title: "Norfolk Terrier"},
                { title: "Norwegian Buhund"},
                { title: "Norwegian Elkhound"},
                { title: "Norwich Terrier"},
                { title: "Old English Sheepdog"},
                { title: "Otterhound"},
                { title: "Papillon"},
                { title: "Parson Russell Terrier"},
                { title: "Patterdale Terrier"},
                { title: "Pekingese"},
                { title: "Pembroke Welsh Corgi"},
                { title: "Petit Basset Griffon Vendeen"},
                { title: "Pharaoh Hound"},
                { title: "Pit Bull Terrier"},
                { title: "Plott Hound"},
                { title: "Podengo Portugueso"},
                { title: "Pointer"},
                { title: "Polish Lowland Sheepdog"},
                { title: "Pomeranian"},
                { title: "Poochy Pals"},
                { title: "Poodle (Miniature)"},
                { title: "Poodle (Standard)"},
                { title: "Poodle (Toy or Tea Cup)"},
                { title: "Portuguese Water Dog"},
                { title: "Presa Canario"},
                { title: "Pug"},
                { title: "Puli"},
                { title: "Pumi"},
                { title: "Pup-pourri"},
                { title: "Rat Terrier"},
                { title: "Redbone Coonhound"},
                { title: "Redtick Coonhound"},
                { title: "Retrievers"},
                { title: "Rhodesian Ridgeback"},
                { title: "Rottweiler"},
                { title: "Russian Wolfhound"},
                { title: "Saluki"},
                { title: "Samoyed"},
                { title: "Schiller Hound"},
                { title: "Schipperke"},
                { title: "Schnauzer"},
                { title: "Scottish Terrier"},
                { title: "Scottish Deerhound"},
                { title: "Sealyham Terrier"},
                { title: "Setters"},
                { title: "Shar Pei"},
                { title: "Sheep Herding Dogs"},
                { title: "Sheltie, Shetland Sheepdog"},
                { title: "Shepherds"},
                { title: "Shiba Inu"},
                { title: "Shih Tzu"},
                { title: "Siberian Husky"},
                { title: "Silky Terrier"},
                { title: "Skye Terrier"},
                { title: "Sloughi"},
                { title: "Smooth Fox Terrier"},
                { title: "Snow Dogs (Husky/Fluffy Types)"},
                { title: "Spaniels (All Types)"},
                { title: "Spaniels (Medium)"},
                { title: "Spaniels (Small)"},
                { title: "Spitz Types (Large)"},
                { title: "Spitz Types (Medium)"},
                { title: "Spitz Types (Small)"},
                { title: "Springer Spaniel"},
                { title: "St. Bernard"},
                { title: "Staffordshire Bull Terrier"},
                { title: "Standard Poodle"},
                { title: "Standard Schnauzer"},
                { title: "Strong but Sweet"},
                { title: "Super-Sized Sweeties"},
                { title: "Sussex Spaniel"},
                { title: "Swedish Vallhund"},
                { title: "Tea Cup Poodle"},
                { title: "Terriers (Medium)"},
                { title: "Terriers (Small)"},
                { title: "Thai Ridgeback"},
                { title: "Tibetan Mastiff"},
                { title: "Tibetan Spaniel"},
                { title: "Tibetan Terrier"},
                { title: "Tons of Love"},
                { title: "Tosa Inu"},
                { title: "Toy Fox Terrier"},
                { title: "Toy Poodle"},
                { title: "Treeing Walker Coonhound"},
                { title: "Vizsla"},
                { title: "Weimaraner"},
                { title: "Welsh Corgi"},
                { title: "Welsh Springer Spaniel"},
                { title: "Welsh Terrier"},
                { title: "Westie, West Highland White Terrier"},
                { title: "Wheaten Terrier"},
                { title: "Whippet"},
                { title: "Wirehaired Fox Terrier"},
                { title: "Wirehaired Pointing Griffon"},
                { title: "Xoloitzcuintle/Mexican Hairless"},
                { title: "Yorkie, Yorkshire Terrier"}


                  ];


                $scope.clicker = function(bread){



                        var userId = window.localStorage.getItem("userIdToken");
                        var link = globalvars.apiUrl + globalvars.usersPath + userId;
                        $http.put(link, {bread: bread.title}).then(function(data){

                              $state.go('editprofile');

                        });




                  };

  }).filter('searchBreads', function(){
    return function (items, query) {
      var filtered = [];
      var letterMatch = new RegExp(query, 'i');
      for (var i = 0; i < items.length; i++) {
        var item = items[i];
        if (query) {
          if (letterMatch.test(item.title.substring(0, query.length))) {
            filtered.push(item);
          }
        } else {
          filtered.push(item);
        }
      }
      return filtered;
    };
})

.controller('breadOptionsCtrl', function($scope, $ionicModal, $http, $stateParams, ProfileFactory, $state, globalvars) {

  $scope.clearSearch = function() {
  $scope.search = '';
};


  $scope.breads = [
              { title: "All"},
              { title: "Mutt-Madness Surprise Mix!"},
              { title: "Mini Mutts (Mucho Love!)"},
              { title: "Mid-Sized Mutts"},
              { title: "Big Mutt-hatten Sky Scrapers"},
              { title: "Barrymore's Buddies"},
              { title: "Taco Bell Dog's Little Amigos"},
              { title: "Eddie &amp; Frasier's Friends!"},
              { title: "Affenpinscher"},
              { title: "Afghan Hound"},
              { title: "Ain't Nothin' but a Hound Dog!"},
              { title: "Airedale Terrier"},
              { title: "Akbash"},
              { title: "Akita"},
              { title: "Alaskan Malamute"},
              { title: "Almost a Horse"},
              { title: "American Bulldog"},
              { title: "American Eskimo Dog"},
              { title: "American Hairless Terrier"},
              { title: "American Pit Bull Terrier"},
              { title: "American Staffordshire Terrier"},
              { title: "American Water Spaniel"},
              { title: "Anatolian Shepherd"},
              { title: "Australian Cattle Dog"},
              { title: "Australian Kelpie"},
              { title: "Australian Shepherd"},
              { title: "Australian Terrier"},
              { title: "Basenji"},
              { title: "Basset Griffon Vendeen"},
              { title: "Basset Hound"},
              { title: "Beagle"},
              { title: "Bearded Collie"},
              { title: "Beauceron"},
              { title: "Bedlington Terrier"},
              { title: "Belgian Laekenois"},
              { title: "Belgian Malinois"},
              { title: "Belgian Shepherd"},
              { title: "Belgian Tervuren"},
              { title: "Bernese Mountain Dog"},
              { title: "Bichon Frise"},
              { title: "Black Mouth Cur"},
              { title: "Black and Tan Coonhound"},
              { title: "Bloodhound"},
              { title: "Blue Heeler"},
              { title: "Lacy/Texas Lacy"},
              { title: "Bluetick Coonhound"},
              { title: "Bobtail"},
              { title: "Bolognese"},
              { title: "Border Collie"},
              { title: "Border Terrier"},
              { title: "Borzoi"},
              { title: "Boston Terrier"},
              { title: "Bouvier des Flandres"},
              { title: "Boxer"},
              { title: "Boykin Spaniel"},
              { title: "Briard"},
              { title: "Brittany"},
              { title: "Brussels Griffon"},
              { title: "Bull Terrier"},
              { title: "Bulldog"},
              { title: "Bullmastiff"},
              { title: "Cairn Terrier"},
              { title: "Canaan Dog"},
              { title: "Canary Dog"},
              { title: "Cane Corso"},
              { title: "Cardigan Welsh Corgi"},
              { title: "Carolina Dog"},
              { title: "Catahoula Leopard Dog"},
              { title: "Cattle Dog"},
              { title: "Cavalier King Charles Spaniel"},
              { title: "Chesapeake Bay Retriever"},
              { title: "Chihuahua"},
              { title: "Chinese Crested"},
              { title: "Chow Chow"},
              { title: "Clumber Spaniel"},
              { title: "Cockapoo"},
              { title: "Cocker Spaniel"},
              { title: "Collie"},
              { title: "Coonhound"},
              { title: "Coonhounds"},
              { title: "Corgi"},
              { title: "Coton de Tulear"},
              { title: "Curly-Coated Retriever"},
              { title: "Cute Canine Crosses"},
              { title: "Dachshund"},
              { title: "Dalmatian"},
              { title: "Dandie Dinmont Terrier"},
              { title: "Deerhound"},
              { title: "Doberman Pinscher"},
              { title: "Dogo Argentino"},
              { title: "Dogue de Bordeaux"},
              { title: "Dutch Shepherd"},
              { title: "English Coonhound"},
              { title: "English Bulldog"},
              { title: "English Mastiff"},
              { title: "English Pointer"},
              { title: "English Setter"},
              { title: "English Sheepdog"},
              { title: "English Shepherd"},
              { title: "English Springer Spaniel"},
              { title: "English Toy Spaniel"},
              { title: "Entlebucher"},
              { title: "Eskimo Dog"},
              { title: "Eskimo Spitz"},
              { title: "Fantastic Fidos"},
              { title: "Feist"},
              { title: "Field Spaniel"},
              { title: "Fila Brasileiro"},
              { title: "Finnish Lapphund"},
              { title: "Finnish Spitz"},
              { title: "Flat-Coated Retriever"},
              { title: "Fox Terrier (Smooth)"},
              { title: "Fox Terrier (Toy)"},
              { title: "Fox Terrier (Wirehaired)"},
              { title: "Fox Terriers (All Types)"},
              { title: "Foxhound"},
              { title: "French Bulldog"},
              { title: "French Mastiff"},
              { title: "Funny-Faced Breeds"},
              { title: "German Pinscher"},
              { title: "German Shepherd Dog"},
              { title: "German Shorthaired Pointer"},
              { title: "German Wirehaired Pointer"},
              { title: "Giant Schnauzer"},
              { title: "Glen of Imaal Terrier"},
              { title: "Go Fetch! Retrievers!"},
              { title: "Golden Retriever"},
              { title: "Goldendoodle"},
              { title: "Gordon Setter"},
              { title: "Great Dane"},
              { title: "Great Pyrenees"},
              { title: "Greater Swiss Mountain Dog"},
              { title: "Greyhound"},
              { title: "Halden Hound"},
              { title: "Harrier"},
              { title: "Havanese"},
              { title: "Hounds (All Types)"},
              { title: "Hounds (Scent Hounds)"},
              { title: "Hounds (Sight Hounds)"},
              { title: "Hovawart"},
              { title: "Hungarian Puli"},
              { title: "Hungarian Water Dog"},
              { title: "Husky"},
              { title: "Ibizan Hound"},
              { title: "Irish Setter"},
              { title: "Irish Terrier"},
              { title: "Irish Water Spaniel"},
              { title: "Irish Wolfhound"},
              { title: "Italian Greyhound"},
              { title: "Italian Spinone"},
              { title: "Jack Russell Terrier"},
              { title: "Japanese Chin"},
              { title: "Jindo"},
              { title: "Kai Dog"},
              { title: "Karelian Bear Dog"},
              { title: "Keeshond"},
              { title: "Kerry Blue Terrier"},
              { title: "King Charles Spaniel"},
              { title: "Kishu"},
              { title: "Komondor"},
              { title: "Kuvasz"},
              { title: "Kyi Leo"},
              { title: "Labradoodle"},
              { title: "Labrador Retriever"},
              { title: "Lakeland Terrier"},
              { title: "Lancashire Heeler"},
              { title: "Lassie's Friends!"},
              { title: "Leonberger"},
              { title: "Lhasa Apso"},
              { title: "Little Fluffy Powder-Puffs of Love"},
              { title: "Little Lovers"},
              { title: "Löwchen"},
              { title: "Maltese"},
              { title: "Manchester Terrier"},
              { title: "Maremma Sheepdog"},
              { title: "Marvelous Mixes"},
              { title: "Mastiff"},
              { title: "Mastiffs (All Types)"},
              { title: "Mexican Hairless"},
              { title: "Miniature Pinscher"},
              { title: "Miniature Poodle"},
              { title: "Miniature Schnauzer"},
              { title: "Mountain Cur"},
              { title: "Munsterlander"},
              { title: "Muttchkins"},
              { title: "Neapolitan Mastiff"},
              { title: "Newfoundland"},
              { title: "Norfolk Terrier"},
              { title: "Norwegian Buhund"},
              { title: "Norwegian Elkhound"},
              { title: "Norwich Terrier"},
              { title: "Old English Sheepdog"},
              { title: "Otterhound"},
              { title: "Papillon"},
              { title: "Parson Russell Terrier"},
              { title: "Patterdale Terrier"},
              { title: "Pekingese"},
              { title: "Pembroke Welsh Corgi"},
              { title: "Petit Basset Griffon Vendeen"},
              { title: "Pharaoh Hound"},
              { title: "Pit Bull Terrier"},
              { title: "Plott Hound"},
              { title: "Podengo Portugueso"},
              { title: "Pointer"},
              { title: "Polish Lowland Sheepdog"},
              { title: "Pomeranian"},
              { title: "Poochy Pals"},
              { title: "Poodle (Miniature)"},
              { title: "Poodle (Standard)"},
              { title: "Poodle (Toy or Tea Cup)"},
              { title: "Portuguese Water Dog"},
              { title: "Presa Canario"},
              { title: "Pug"},
              { title: "Puli"},
              { title: "Pumi"},
              { title: "Pup-pourri"},
              { title: "Rat Terrier"},
              { title: "Redbone Coonhound"},
              { title: "Redtick Coonhound"},
              { title: "Retrievers"},
              { title: "Rhodesian Ridgeback"},
              { title: "Rottweiler"},
              { title: "Russian Wolfhound"},
              { title: "Saluki"},
              { title: "Samoyed"},
              { title: "Schiller Hound"},
              { title: "Schipperke"},
              { title: "Schnauzer"},
              { title: "Scottish Terrier"},
              { title: "Scottish Deerhound"},
              { title: "Sealyham Terrier"},
              { title: "Setters"},
              { title: "Shar Pei"},
              { title: "Sheep Herding Dogs"},
              { title: "Sheltie, Shetland Sheepdog"},
              { title: "Shepherds"},
              { title: "Shiba Inu"},
              { title: "Shih Tzu"},
              { title: "Siberian Husky"},
              { title: "Silky Terrier"},
              { title: "Skye Terrier"},
              { title: "Sloughi"},
              { title: "Smooth Fox Terrier"},
              { title: "Snow Dogs (Husky/Fluffy Types)"},
              { title: "Spaniels (All Types)"},
              { title: "Spaniels (Medium)"},
              { title: "Spaniels (Small)"},
              { title: "Spitz Types (Large)"},
              { title: "Spitz Types (Medium)"},
              { title: "Spitz Types (Small)"},
              { title: "Springer Spaniel"},
              { title: "St. Bernard"},
              { title: "Staffordshire Bull Terrier"},
              { title: "Standard Poodle"},
              { title: "Standard Schnauzer"},
              { title: "Strong but Sweet"},
              { title: "Super-Sized Sweeties"},
              { title: "Sussex Spaniel"},
              { title: "Swedish Vallhund"},
              { title: "Tea Cup Poodle"},
              { title: "Terriers (Medium)"},
              { title: "Terriers (Small)"},
              { title: "Thai Ridgeback"},
              { title: "Tibetan Mastiff"},
              { title: "Tibetan Spaniel"},
              { title: "Tibetan Terrier"},
              { title: "Tons of Love"},
              { title: "Tosa Inu"},
              { title: "Toy Fox Terrier"},
              { title: "Toy Poodle"},
              { title: "Treeing Walker Coonhound"},
              { title: "Vizsla"},
              { title: "Weimaraner"},
              { title: "Welsh Corgi"},
              { title: "Welsh Springer Spaniel"},
              { title: "Welsh Terrier"},
              { title: "Westie, West Highland White Terrier"},
              { title: "Wheaten Terrier"},
              { title: "Whippet"},
              { title: "Wirehaired Fox Terrier"},
              { title: "Wirehaired Pointing Griffon"},
              { title: "Xoloitzcuintle/Mexican Hairless"},
              { title: "Yorkie, Yorkshire Terrier"}


                ];


              $scope.clicker = function(bread){



                      var userId = window.localStorage.getItem("userIdToken");
                      var link = globalvars.apiUrl + globalvars.usersPath + userId;
                      $http.put(link, {options: {bread: bread.title}}).then(function(data){

                              $state.go('editsettings');

                      });




                };

}).filter('searchBreads', function(){
  return function (items, query) {
    var filtered = [];
    var letterMatch = new RegExp(query, 'i');
    for (var i = 0; i < items.length; i++) {
      var item = items[i];
      if (query) {
        if (letterMatch.test(item.title.substring(0, query.length))) {
          filtered.push(item);
        }
      } else {
        filtered.push(item);
      }
    }
    return filtered;
  };
})


  .controller('SettingsCtrl', function($scope, $ionicModal, $ionicPlatform, $ionicLoading, $ionicPopup, $http, $stateParams, ProfileFactory, $state, globalvars, $ionicPopup, dashModel, price) {

        var userId = window.localStorage.getItem("userIdToken");
        var admob = window.localStorage.getItem("admob");


        var link = globalvars.apiUrl + globalvars.usersPath + userId;



        $ionicLoading.show({
          template: '<ion-spinner></ion-spinner>'
        });

        $scope.modules = dashModel.getAvailableProducts();





        $scope.fbuserId =  window.localStorage.getItem("fbuserId");
        $scope.fbuserName =  window.localStorage.getItem("fbuserName");
        $scope.fbuserAbout =  window.localStorage.getItem("fbuserAbout");

        $http.get(link).then(function (res){

             console.log(res.data);
             $scope.petDetails = res.data;


        });



       $scope.goBack = function() {
          $state.go('home.explore');
        };


       $scope.logout = function () {
               admob.showBannerAd(false);
               window.localStorage.removeItem("fbuserId");
               window.localStorage.removeItem("fbuserName");
               window.localStorage.removeItem("fbuserAbout");
               window.localStorage.removeItem("userIdToken");
               facebookConnectPlugin.logout();
               $state.go('welcome');
        };


      $scope.editprofile = function () {
              $state.go('editprofile');
      };

      $scope.editsettings = function () {


              $state.go('editsettings');

      };



      $scope.promotion = function (data) {


              console.log(data);
              var link = 'https://api.petpalapps.com/api/v1/promos?query={"promocode":"' + data.code + '"}';
              $http.get(link).then(function(result){

                    console.log(result.data[0]);
                    var couponObject = result.data[0];
                    if (couponObject.expired === false) {
                      var link = globalvars.apiUrl + globalvars.usersPath + userId;
                      $http.patch(link, {admob: false}).then(function(data){

                          var couponlink = 'https://api.petpalapps.com/api/v1/promos/' + couponObject._id;
                          $http.patch(couponlink, {expired: true});
                          $ionicPopup.alert({
                              title: 'Coupon',
                              template: 'Successed'
                          });
                          window.localStorage.setItem("admob", true);

                      });

                    }

                    else {

                      $ionicPopup.alert({
                          title: 'Coupon',
                          template: 'Coupon already used please try another coupon!'
                      });
                      window.localStorage.setItem("admob", true);

                    }

              });

      };


      $scope.premium = function () {

        $ionicLoading.show({
          template: '<ion-spinner></ion-spinner>'
        });


        inAppPurchase
.getProducts(['com.petpalmob.petpal.premiumpetmet'])
.then(function (products) {
      console.log(products[0].productId);
      inAppPurchase
     .buy(products[0].productId)
     .then(function (data) {
       console.log(JSON.stringify(data));
       console.log('consuming transactionId: ' + data.transactionId);
       return inAppPurchase.consume(data.type, data.receipt, data.signature);
     })
     .then(function () {
       var alertPopup = $ionicPopup.alert({
         title: 'Purchase was successful!',
         template: 'Check your console log for the transaction data'
       });
       console.log('consume done!');
       $ionicLoading.hide();
       var link = globalvars.apiUrl + globalvars.usersPath + userId;
       $http.patch(link, {admob:  false});



     })
     .catch(function (err) {
       $ionicLoading.hide();
       console.log(err);
       $ionicPopup.alert({
         title: 'Something went wrong',
         template: 'Check your console log for the error details'
       });
     });
})
.catch(function (err) {
      console.log(err);
});


      };

      $scope.premium = function () {

        $ionicLoading.show({
          template: '<ion-spinner></ion-spinner>'
        });


        inAppPurchase
.getProducts(['com.petpalmob.petpal.premiumpetmet'])
.then(function (products) {
      console.log(products[0].productId);
      inAppPurchase
     .buy(products[0].productId)
     .then(function (data) {
       console.log(JSON.stringify(data));
       console.log('consuming transactionId: ' + data.transactionId);
       return inAppPurchase.consume(data.type, data.receipt, data.signature);
     })
     .then(function () {
       var alertPopup = $ionicPopup.alert({
         title: 'Purchase was successful!',
         template: 'Check your console log for the transaction data'
       });
       console.log('consume done!');
       $ionicLoading.hide();
       var link = globalvars.apiUrl + globalvars.usersPath + userId;
       $http.patch(link, {admob:  false});



     })
     .catch(function (err) {
       $ionicLoading.hide();
       console.log(err);
       $ionicPopup.alert({
         title: 'Something went wrong',
         template: 'Check your console log for the error details'
       });
     });
})
.catch(function (err) {
      console.log(err);
});


      };




      $ionicLoading.hide();
  })

  .controller('ProfileEditControler', function($scope, $http, $state, $ionicLoading, $cordovaCamera, $cordovaFileTransfer, globalvars) {

    var userId = window.localStorage.getItem("userIdToken");
    var link = globalvars.apiUrl + globalvars.usersPath + userId;

    $http.get(link).then(function (res){

         console.log(res.data);
          $scope.petDetails = res.data;


    });

    $scope.descChange = function(data) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.put(link,  {description: data});


    };

    $scope.nameChange = function(data) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.put(link,  {name: data});


    };

    $scope.owneraboutChange = function(data) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.put(link,  {aboutowner: data});


    };

    document.addEventListener("deviceready", function () {
      options = {
        quality: 80,
        destinationType: Camera.DestinationType.FILE_URI,
        sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
        mediaType: Camera.MediaType.PICTURE,
        allowEdit: true,
        encodingType: Camera.EncodingType.JPEG,
        targetWidth: 800,
        targetHeight: 800,
        popoverOptions: CameraPopoverOptions,
        saveToPhotoAlbum: false,
        correctOrientation:true
      };
    });

    $scope.ProfileOwnerPicUpload = function() {



      if (Camera === undefined) return false;

      $cordovaCamera.getPicture(options)
        .then(function(imageData) {
          // $scope.imgSrc = "data:image/jpeg;base64," + imageData;

          console.log(imageData);
          $ionicLoading.show({
            template: '<ion-spinner></ion-spinner>'
          });

          var url = globalvars.serverUrl + "/profile/upload";
 //target path may be local or url
          var targetPath = imageData;
          var filename = targetPath.split("/").pop();
          var options = {
              fileKey: "avatar",
              fileName: filename,
              chunkedMode: false,
              mimeType: "image/jpeg",
              headers: {
        Connection: "close"
    }
          };
    $cordovaFileTransfer.upload(url, targetPath, options).then(function(result) {

            console.log(result.response);
            var userId = window.localStorage.getItem("userIdToken");
            var link = globalvars.apiUrl + globalvars.usersPath + userId;
            $http.put(link, {images:  {ownerPic: result.response} });
            $ionicLoading.hide();


        }, function(err) {
            console.log(err);

        }, function (progress) {
              console.log(progress);
    });





        }, function(err) {
          // error
        });

    };



    $scope.goBack = function() {
      $state.go('settings');
    };

    $scope.AgeStates = function() {
      $state.go('ageProfile');
    };

    $scope.GenderStates = function() {
      $state.go('genderProfile');
    };

    $scope.TypeStates = function() {
      $state.go('typeProfile');
    };

    $scope.BreadStates = function() {
      $state.go('breadProfile');
    };

  })
  .controller('SettingsEditControler', function($scope, $ionicModal, $state, $http, $ionicHistory, globalvars) {


      var userId = window.localStorage.getItem("userIdToken");
      var link = globalvars.apiUrl + globalvars.usersPath + userId;

      $http.get(link).then(function (res){

           console.log(res.data);
           $scope.petDetails = res.data;

      });

      $scope.BreadOptionStates = function() {
        $state.go('breadOption');
      };

      $scope.GenderOptionStates = function() {
        $state.go('genderOption');
      };

      $scope.TypeOptionStates = function() {
        $state.go('typeOption');
      };

      $scope.goBack = function() {
        $state.go('settings');
      };

    $scope.genderState = function(){

         $state.go('gender');

    };


    $scope.ageChange = function(data) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.put(link, {options: {age: data}});


    };

    $scope.shareButton = function(data) {



                var options = {
            message: 'Share PetPal Experience', // not supported on some apps (Facebook, Instagram)
            subject: 'Next things for pets', // fi. for email
            files: ['', ''], // an array of filenames either locally or remotely
            url: 'https://www.petpalapps.com',
            chooserTitle: 'PetPal' // Android only, you can override the default share sheet title
          }

          var onSuccess = function(result) {
            console.log("Share completed? " + result.completed); // On Android apps mostly return false even while it's true
            console.log("Shared to app: " + result.app); // On Android result.app is currently empty. On iOS it's empty when sharing is cancelled (result.completed=false)
          }

          var onError = function(msg) {
            console.log("Sharing failed with message: " + msg);
          }

          window.plugins.socialsharing.shareWithOptions(options, onSuccess, onError);



    };

    $scope.weightChange = function(data) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.put(link, {options: {weight: data}});


    };

    $scope.maxDistanceChange = function(data) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.put(link, {options: {maxDistance: data}});


    };

    $scope.newMatcheschange = function(chkStatus) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.put(link, {notifications: {newMatches: chkStatus}});


    };

    $scope.newMessageschange = function(chkStatus) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.put(link, {notifications: {Messages: chkStatus}});


    };

    $ionicModal.fromTemplateUrl('templates/modals/privacy.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
    });

    $scope.goPrivacy = function() {

        $scope.modal.show();

    };

    $scope.closePrivacyModal = function() {
      $scope.modal.hide();

    };

    $ionicModal.fromTemplateUrl('templates/modals/terms.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
    });

    $scope.goTerms = function() {

        $scope.modal.show();

    };

    $scope.closeTermsModal = function() {
      $scope.modal.hide();

    };

    $ionicModal.fromTemplateUrl('templates/modals/safety.html', {
      scope: $scope,
      animation: 'slide-in-up'
    }).then(function(modal) {
      $scope.modal = modal;
    });

    $scope.goSafety = function() {

        $scope.modal.show();

    };

    $scope.closeSafetyModal = function() {
      $scope.modal.hide();

    };


  })

  .controller('MatchesCtrl', function($scope, $ionicLoading, $ionicModal, $http, globalvars, dataShare) {

    window.localStorage.setItem("newnotification", false);
    var userId = window.localStorage.getItem("userIdToken");
    var me = globalvars.apiUrl + globalvars.usersPath + userId;
    $http.get(me).then(function(result){

      console.log(result.data);
      $scope.userDetails = result.data;

    });

    $ionicLoading.show({
      template: '<ion-spinner></ion-spinner>'
    });

     $scope.humanize = function(timestamp){
       return moment(timestamp).fromNow();
     };

     var url = 'https://api.petpalapps.com/allmatches';
    $http.post(url, {userid: userId}).then(function(result){


            console.log(result);
            $scope.matches = result.data;
            $ionicLoading.hide();




    });




     $ionicModal.fromTemplateUrl('templates/modals/help.html', {
       scope: $scope,
       animation: 'slide-in-up'
     }).then(function(modal) {
       $scope.helpModal = modal;
     });

     $scope.closeHelpModal = function() {
       $scope.helpModal.hide();
       $http.get(me).then(function(result){


             if (result.data.admob === true) {
                 admob.showBannerAd(true);

             }



       });

     };

     $scope.openHelpModal = function() {
       $scope.helpModal.show();
       $http.get(me).then(function(result){


             if (result.data.admob === true) {
                 admob.showBannerAd(false);

             }



       });
     }


  })

  // Inspired by Elastichat http://codepen.io/rossmartin/pen/XJmpQr
  .controller('MessagingCtrl', function($scope, $http, $timeout, $state, $stateParams, globalvars, SocketIOService, $ionicScrollDelegate, $timeout, $ionicActionSheet, dataShare) {

    console.log($stateParams);
    var conversationId =  $stateParams.id;
    var matchUserId = $stateParams.matchid;
    var pushId = $stateParams.pushid;
    var name = $stateParams.name;
    var reportedBy =  window.localStorage.getItem("userIdToken");
    console.log(conversationId);
    console.log(matchUserId);

    $scope.ownername = window.localStorage.getItem("fbuserName");
    console.log($scope.ownername);

    var link = globalvars.apiUrl + globalvars.usersPath + matchUserId;

    $http.get(link).then(function (res){

         console.log(res.data);
         $scope.chatUserDetails = res.data;

    });

    var link = globalvars.apiUrl + globalvars.conversationPath + conversationId;
    $http.get(link).then(function(res){

        console.log(res);
        $scope.conversation = res.data;
        setTimeout(function(){ $ionicScrollDelegate.scrollBottom(true); }, 1000);


    });

    SocketIOService.emit('subscribe', conversationId);



    var userId = window.localStorage.getItem("userIdToken");
    var link = globalvars.apiUrl + globalvars.usersPath + userId;
    var messageLink = globalvars.apiUrl + globalvars.messsagesPath;
    $scope.backToMatches = function(data){

        SocketIOService.emit('unsubscribe', conversationId);
        $state.go('matches');

    };
    $http.get(link).then(function (res){

         console.log(res.data);
         $scope.userDetails = res.data;

    });

    $scope.me = window.localStorage.getItem("userIdToken");

    var me = $scope.me;


    $scope.messages = [];
    $scope.chat = 'devsbeer';

    var QueryLink = globalvars.serverUrl + '/api/v1/Messages?query={"conversation_id":"'+  conversationId + '"}';

    $http.get(QueryLink).then(function (res){


         console.log(res);
         $scope.messages = res.data;

    });



    $scope.isMe = function(user){
      if($scope.me === user){
        return true;
      }
      return false;
    };

    $scope.sendText = function(){
      var msg = {

        'type': 'message',
        'avatar': $scope.userDetails.images.positionOne,
        'user': $scope.me,
        'text': $scope.message,
        'time': moment()
      };


      SocketIOService.emit('send message', {
      room: conversationId,
      message: msg
      });

      $scope.messages.push(msg);

      $http.post(messageLink, {

        type: msg.type,
        avatar: msg.avatar,
        text: msg.text,
        created_at: moment(),
        user: userId,
        conversation_id: conversationId


       }).then(function(data){

         $ionicScrollDelegate.scrollBottom(true);
         window.plugins.OneSignal.getIds(function(ids) {
             var notificationObj = { contents: {en: msg.text }, headings: {en: $scope.userDetails.name },
                               include_player_ids: [pushId],  ios_badgeType: 'Increase',
    ios_badgeCount: 1, data: {id: conversationId, pushid: pushId, matchid: $scope.chatUserDetails._id }};
             window.plugins.OneSignal.postNotification(notificationObj,
               function(successResponse) {
                   console.log("Notification Post Success:", successResponse);
             },
             function (failedResponse) {
                   console.log("Notification Post Failed: ", failedResponse);

             }
             );
         });

      });

      $scope.message = '';


    };



    $scope.humanize = function(timestamp){
      return moment(timestamp).fromNow();
    };


    SocketIOService.on('conversation private post', function(msg){

      msg.type = 'message';
      $scope.messages.push(msg);
      $ionicScrollDelegate.scrollBottom(true);


    });


    $scope.showUserOptions = function() {
      $http.get(link).then(function(result){


            if (result.data.admob === true) {
                admob.showBannerAd(false);

            }



      });
      var hideSheet = $ionicActionSheet.show({
        buttons: [
          { text: 'Report ' +  $scope.chatUserDetails.name },
          { text: 'Show ' +  $scope.chatUserDetails.name + '\'s profile' }
        ],
        destructiveText: 'Unmatch ' + $scope.chatUserDetails.name,
        cancelText: 'Cancel',
        cancel: function() {
          $http.get(link).then(function(result){


                if (result.data.admob === true) {
                    admob.showBannerAd(true);

                }



          });
          },
        buttonClicked: function(index) {
          $http.get(link).then(function(result){


                if (result.data.admob === true) {
                    admob.showBannerAd(true);

                }



          });
           
          if (index === 0) {
              $http.post(report, {reportedUser: matchUserId, reportedBy: reportedBy });
          }

          else if (index === 1) {
            $state.go('home.profile', {isFromCard: true, id: $scope.chatUserDetails._id, fbid: $scope.chatUserDetails.facebookToken, distance: $scope.chatUserDetails.distance });
          }

          return true;
        },
        destructiveButtonClicked: function() {
        var link = globalvars.apiUrl + globalvars.conversationPath + conversationId;
        $http.delete(link);
        $state.go('matches');
        return true;
      }
      });
    }


  })
