// Source: https://www.thepolyglotdeveloper.com/2015/01/making-tinder-style-swipe-cards-ionic-framework/
angular.module('starter.directives', [])
  .directive('noScroll', function() {
    return {
      restrict: 'A',
      link: function($scope, $element, $attr) {
        $element.on('touchmove', function(e) {
          e.preventDefault();
        });
      }
    }
  })

  .directive('photoPickable', function() {
    return {
      restrict: 'AE',
      scope: {
        number: '@',
        imgSrc: '=',
        position: '@'
      },
      template: '' +
            '<div class="photo-pickable" ng-click="pick(number)">' +
              '<span class="photo-number text-lg light">{{number}}</span>' +
              '<img ng-src="{{imgSrc}}" class="w-full r-3x" alt="">' +
            '</div>',
      controller: function($scope, $http, $cordovaCamera, $cordovaFileTransfer, globalvars) {


        var options;

        var number = $scope.number;

        if (number == 1) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.get(link).then(function (res){

               console.log(res.data);
                $scope.imgSrc = res.data.images.positionOne;


          });

        }

        else if (number == 2) {

          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.get(link).then(function (res){

               console.log(res.data);
                $scope.imgSrc = res.data.images.positionTwo;


          });

        }

        else {
          var userId = window.localStorage.getItem("userIdToken");
          var link = globalvars.apiUrl + globalvars.usersPath + userId;
          $http.get(link).then(function (res){

               console.log(res.data);
               $scope.imgSrc = res.data.images.positionThree;


          });
        }

        $scope.imgSrc = 'img/default.png';

        document.addEventListener("deviceready", function () {
          options = {
            quality: 80,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: Camera.MediaType.PICTURE,
            allowEdit: true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 800,
            targetHeight: 800,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation:true
          };
        });

        $scope.pick = function(data) {
          if (Camera === undefined) return false;
          var position = data;
          $cordovaCamera.getPicture(options)
            .then(function(imageData) {
              // $scope.imgSrc = "data:image/jpeg;base64," + imageData;

              console.log(imageData);


              var url = globalvars.serverUrl + "/profile/upload";
     //target path may be local or url
              var targetPath = imageData;
              var filename = targetPath.split("/").pop();
              var options = {
                  fileKey: "avatar",
                  fileName: filename,
                  chunkedMode: false,
                  mimeType: "image/jpg"
              };

        $cordovaFileTransfer.upload(url, targetPath, options).then(function(result) {


                if (position === "1" ) {


                  var userId = window.localStorage.getItem("userIdToken");
                  var link = globalvars.apiUrl + globalvars.usersPath + userId;
                  $http.put(link, {images:  {positionOne: result.response} }).then( function (data){});

                }

                else if (position === "2") {

                  var userId = window.localStorage.getItem("userIdToken");
                  var link = globalvars.apiUrl + globalvars.usersPath + userId;
                  $http.put(link, {images:  {positionTwo: result.response} }).then( function (data){});

                  }

                else {

                  var userId = window.localStorage.getItem("userIdToken");
                  var link = globalvars.apiUrl + globalvars.usersPath + userId;
                  $http.put(link, {images:  {positionThree: result.response} }).then( function (data){});
                }


            }, function(err) {
                console.log(err);

            }, function (progress) {
                  console.log(progress);
        });




              $scope.imgSrc = imageData;
            }, function(err) {
              // error
            });
        }
      }
    }
  }).directive('photoProfile', function() {
    return {

      controller: function($scope, $http, $ionicLoading, $cordovaCamera, $cordovaFileTransfer, globalvars) {

        document.addEventListener("deviceready", function () {
          options = {
            quality: 80,
            destinationType: Camera.DestinationType.FILE_URI,
            sourceType: Camera.PictureSourceType.PHOTOLIBRARY,
            mediaType: Camera.MediaType.PICTURE,
            allowEdit: true,
            encodingType: Camera.EncodingType.JPEG,
            targetWidth: 800,
            targetHeight: 800,
            popoverOptions: CameraPopoverOptions,
            saveToPhotoAlbum: false,
            correctOrientation:true
          };
        });

        $scope.pick = function() {
          if (Camera === undefined) return false;

          $cordovaCamera.getPicture(options)
            .then(function(imageData) {
              // $scope.imgSrc = "data:image/jpeg;base64," + imageData;

                console.log(imageData);
                $ionicLoading.show({
                  template: '<ion-spinner></ion-spinner>'
                });

                var url = globalvars.serverUrl + "/profile/upload";
                  //target path may be local or url
                var targetPath = imageData;
                var filename = targetPath.split("/").pop();
                var options = {
                    fileKey: "avatar",
                    fileName: filename,
                    chunkedMode: false,
                    mimeType: "image/jpg"
                };
                
        $cordovaFileTransfer.upload(url, targetPath, options).then(function(result) {

                var userId = window.localStorage.getItem("userIdToken");
                var link = globalvars.apiUrl + globalvars.usersPath + userId;
                $http.put(link, {images: [ {positionOne: result.response} ]});
                $ionicLoading.hide();


            }, function(err) {
                console.log(err);

            }, function (progress) {
                  console.log(progress);
        });





            }, function(err) {
              // error
            });
        }
      }
    }
  })
