angular.module('starter.services', [])
.filter('sumByKey', function() {
     return function(data, key) {
         if (typeof(data) === 'undefined' || typeof(key) === 'undefined') {
             return 0;
         }

         var sum = 0;
         for (var i = data.length - 1; i >= 0; i--) {
             sum += parseInt(data[i][key]);
         }

         return sum;
     };
 })
.factory('AgeFactory', function() {

      var ages = [

            {value: '1'},
            {value: '2'},
            {value: '3'},
            {value: '4'},
            {value: '5'},
            {value: '6'},
            {value: '7'},
            {value: '8'},
            {value: '9'},
            {value: '10'},
            {value: '11'},
            {value: '12'},
            {value: '13'},
            {value: '14'},
            {value: '15'},
            {value: '16'},
            {value: '17'},
            {value: '18'},


      ]

      return ages;


})
.factory('getOptions', function($http, globalvars) {


   return {



      list: function() {

        var userId = window.localStorage.getItem("userIdToken");
        var link = globalvars.apiUrl + globalvars.usersPath + userId;


        return $http.get(link).then(function(result) {
            return result;
        });

      }


    };



}).factory('dataShare',function($rootScope){
  var service = {};
  service.data = false;
  service.sendData = function(data){
      this.data = data;
      $rootScope.$broadcast('data_shared');
  };
  service.getData = function(){
    return this.data;
  };
  return service;
})
.factory('GenderFactory', function() {


        var gender = [


            {value: 'Male'},
            {value: 'Female'}

        ]

        return gender;


})
.factory('GetAllUsers', function($http, globalvars, getOptions) {




  //



   return {



      getprogramList: function() {

        var seenUsers = [];
        var userId = window.localStorage.getItem("userIdToken");
        var link = globalvars.apiUrl + '/Seen?query={"userId":"' + userId + '"}';

        $http.get(link).then(function (res){

              angular.forEach(res.data, function(data) {

                   var pushNode = '"' + data.SeenUserId + '"';
                   seenUsers.push(pushNode);

              });


        });

        var seenUsersArray = seenUsers;



        getOptions.list().then(function(result){

              var options = result.data.options;
              window.localStorage.setItem("optionsGender", result.data.options.gender);
              window.localStorage.setItem("optionsBread", result.data.options.bread);
              window.localStorage.setItem("optionsAge", result.data.options.age);
              window.localStorage.setItem("optionsMaxDistance", result.data.options.maxDistance);
              window.localStorage.setItem("optionsCoordinates", result.data.loc.coordinates);


        });

        var coordinates = window.localStorage.getItem("optionsCoordinates");
        var distance = window.localStorage.getItem("optionsMaxDistance");
        var maxDistance = (distance * 1609.34);
        var gender = window.localStorage.getItem("optionsGender");
        var age = window.localStorage.getItem("optionsAge");
        var bread = window.localStorage.getItem("optionsBread");


        var queryLink = globalvars.apiUrl + '/Users?query={"gender": "' + gender + '", "age":{"$lte": ' + age + '},  "_id":{"$nin":["579bcdb48441e6e461d99e2b"]}, "loc.coordinates": {"$near": { "$geometry": { "type": "Point",  "coordinates": [' + coordinates + ']},"$maxDistance":' + maxDistance + '}}}';
        return $http.get(queryLink).then(function(result) {
            return result;
        });
     }


    };

}).service('ProfileFactory', function($http, globalvars) {

     var userId = window.localStorage.getItem("userIdToken");
     var link = globalvars.apiUrl + globalvars.usersPath + userId;

     $http.get(link).then(function (res){

           var userDataDetails = JSON.stringify(res);
           console.log(userDataDetails);

     });

   }).factory('ServiceLocation', function($http, globalvars, $ionicPlatform, $cordovaGeolocation) {


     var positionOptions = {timeout: 10000, enableHighAccuracy: false};

      return {
       getPosition: function() {
         return $ionicPlatform.ready()
           .then(function() {
             return $cordovaGeolocation.getCurrentPosition(positionOptions);
           })
       }
      };


   }).service('AllMessagesFactory', function($http, globalvars) {

    var userId = window.localStorage.getItem("userId");
    var link = globalvars.apiUrl + globalvars.usersPath + userId + '/messages/';

     $http.get(link).then(function (res){

         window.localStorage.setItem("AllMessagesData", JSON.stringify(res));

     });

   }) .factory('dashModel', function () {
    // Some fake testing data
    var modules = [
      {
        id: 0,
        name: 'Premium Ad Free',
        description: 'Premium',
        appleStoreId: 'com.petpalapps.petpalmob.petmetpremium'
      }

    ];

    return {
      getAvailableProducts: function () {
        return modules;
      }
    };
  })
  .factory('price', function ($q, $timeout) {
    var key = '';

    var price = {
      modulesWithPrice: [],
      storeInit: function () {
        return $q(function (resolve, reject) {
          if (window.store) {

            function success() {
              resolve();
            };

            function error() {
              reject();
            };

            if (ionic.Platform.isIOS()) {
              key = 'appleStoreId';
              storekit.init({}, function () {
                resolve();
              }, function () {
                reject();
              });

            } else if (ionic.Platform.isAndroid()) {
              key = 'googleMarketId';
              store.inappbilling.init(success, error);
            } else {
              key = 'microsoftStoreId';
              store.inappbilling.init(success, error);
            }
          }
        });
      },
      getPrices: function (products) {
        var deferred = $q.defer();

        console.info('Getting prices from store');
        if (!window.store) {
          deferred.reject();
          return deferred.promise;
        }
        var skus = price.getSKUS(products);

        if (!skus.length) {
          deferred.reject();
          return deferred.promise;
        }

        function successHandler(res) {
          console.info('successHandler', res);
          deferred.resolve(res);
        }

        function errorHandler(error) {
          console.info(error);
          deferred.reject();
        }

        if (key === 'appleStoreId') {
          var skusIOS = '';
          skus.forEach(function (sku) {
            skusIOS += sku + ',';
          });
          storekit.load(
            skusIOS,
            successHandler,
            errorHandler
          );
        } else if (key === 'googleMarketId') {
          store.inappbilling.getProductDetails(
            successHandler,
            errorHandler,
            skus
          );

        } else if (key === 'microsoftStoreId') {
          store.inappbilling.getProductDetails(
            successHandler,
            errorHandler,
            skus
          );
        }

        return deferred.promise;
      },
      getSKUS: function (products) {
        var skus = [];
        products.forEach(function (product) {
          skus.push(product[key]);
        });
        return skus;
      },
      addPricesToModule: function (products, modules) {
        var modulesWithPrice = [];
        modules.forEach(function (module) {
          products.forEach(function (product) {
            if (product.productId === module[key] || product.id === module[key]) {
              if (key === 'microsoftStoreId') {
                module.price = product.formattedPrice;
              } else {
                module.price = product.price;
              }
              modulesWithPrice.push(module);
            }
          })
        });
        price.modulesWithPrice = modulesWithPrice;
      },
      proceedToPayment: function (product) {
        store.register({
          id: product[key],
          type: store.NON_CONSUMABLE
        });
        // item_walker = store.get( product[key]);
        // console.log('item_walker',item_walker);

        var defer = $q.defer();
        store.refresh();

        // api.purchaseStart(product.id)
        //   .then(function (data) {

        store.order(product[key]);
        store.when(product[key])
          .approved(function (result) {
            console.log('result!!!!', result);
            if (key === 'appleStoreId' && result.transaction && result.transaction.appStoreReceipt
              || key === 'googleMarketId' && result.transaction && result.transaction.receipt
              || key === 'microsoftStoreId' && result.transaction && result.transaction.receipt) {

              var dataForConfirmPurchases = {
                appleStoreResponse: key === 'appleStoreId' ? JSON.stringify(result).replace(/\\/g, '') : '',
                googleMarketReceipt: key === 'googleMarketId' ? result.transaction.receipt.replace(/\\/g, '') : '',
                microsoftStoreReceipt: key === 'microsoftStoreId' ? btoa(result.transaction.receipt.replace(/\\/g, '')) : '',
                googleMarketSignature: key === 'googleMarketId' ? result.transaction.signature : ''
              };
              // api.purchaseFinish(product.id, data.modulePurchase.id, dataForconfirmPurchases)
              //   .then(function (data) {
              //     if (data.modulePurchase.valid) {
              //       defer.resolve();
              //     } else {
              //       defer.reject('Server error.');
              //     }
              //   })
              //   .catch(function (e) {
              //     defer.reject(langConfig.error.requestProblem);
              //   });
            }
          });
        store.when(product[key]).cancelled(function () {
          defer.reject();
        });
        store.when(product[key]).error(function () {
          defer.reject(langConfig.error.requestProblem);
        });
        store.when(product[key]) //product already purchased
          .owned(function (result) {
            console.log(result);
            if (key === 'appleStoreId' && result.transaction.appStoreReceipt || key === 'googleMarketId' && result.transaction && result.transaction.receipt || key === 'microsoftStoreId' && result.transaction && result.transaction.receipt) {
              var dataForConfirmPurchases = {
                appleStoreResponse: key === 'appleStoreId' ? JSON.stringify(result).replace(/\\/g, '') : '',
                googleMarketReceipt: key === 'googleMarketId' ? result.transaction.receipt.replace(/\\/g, '') : '',
                microsoftStoreReceipt: key === 'microsoftStoreId' ? btoa(result.transaction.receipt.replace(/\\/g, '')) : '',
                googleMarketSignature: key === 'googleMarketId' ? result.transaction.signature : ''
              };
              // api.purchaseFinish(product.id, data.modulePurchase.id, dataForConfirmPurchases)
              //   .then(function (data) {
              //     if (data.modulePurchase.valid) {
              //       defer.resolve();
              //     } else {
              //       defer.reject('Server error');
              //     }
              //   })
              //   .catch(function (e) {
              //     defer.reject(langConfig.error.requestProblem);
              //   });
            }
          });
        // })
        // .catch(function () {
        //   defer.reject(langConfig.error.requestProblem);
        // });
        return defer.promise;
      }
    };
    return price;
  });
